'This file is designed to be GlobalExecute'd into the master script
'It contains MapPoint-specific variables and code


'######################################################################
'Global variables to be used
'######################################################################
Dim Initialized
Dim MapPointApp
Dim ActiveMap
Dim HistoryPushpins
Dim MotionPushpins

Dim WEPPushpins, NonWEPPushpins
Dim pWEPPushpins, pNonWEPPushpins

Dim Vehicle

Dim BSSID_Dictionary
Dim IsScanning
Dim HadGPSData
Dim GPSLatitude, GPSLongitude, GPSAltitude
Dim LastHighlighted
Dim crumbLat, crumbLon

Dim TrackColor(7),Strength


Dim BSSID_Signal


'######################################################################
'Initialization
'######################################################################

AddItemContextMenu "HighlightOnMap", "Highlight on map"
'AddItemContextMenu "AddToDefaultMap", "Add to map" 'Just Testing

Set LastHighlighted = Nothing
'smt 20040609
'Set WLANPushpins = Nothing
Set WEPPushpins = Nothing
Set NonWEPPushpins = Nothing
'end smt 20040609
'smt 20040611
Trackcolor(0)	= RGB(0,0,0)	'black - not picking up anything
TrackColor(1)	= RGB(255,0,0)	'snr level 1
TrackColor(2)	= RGB(128,0,128)	'etc..
TrackColor(3)	= RGB(64,0,192)
TrackColor(4)	= RGB(0,0,255)
TrackColor(5)	= RGB(0,128,128)
TrackColor(6)	= RGB(0,192,64)
TrackColor(7)	= RGB(0,255,0)	'damn! I can hear it in my head!!
'end smt 20040611


Initialize

Sub Initialize()
	On Error Resume Next

	HadGPSData = False

	Set BSSID_Dictionary = CreateObject("Scripting.Dictionary")
	Set BSSID_Signal = CreateObject("Scripting.Dictionary")

	' begin 20040618
	' Are we using a default map?
	If UseDefaultMap Then
		Set MapPointApp = CreateObject("MapPoint.Application")
		MapPointApp.Visible = True
		MapPointApp.UserControl = False
		MapPointApp.OpenMap(DefaultMapLocation)
		If Err <> 0 Then
			Msgbox "Unable to open default map!", 16, "Critical Error!"
			Err.Clear
			UseMapPoint = False
			'''Because UseMappoint is set to false, there isn't a need to unset anything
			'ZoomToStartLoc = False
			'DropCrumbs = False
			'TrackVehicle = False
			'Place = ""
			MapPointApp.ActiveMap.Saved = True
			MapPointApp.Quit
			Exit Sub
		End If
	Else
		' end 20040618
		' Try to get a handle to an existing instance of MapPoint
		Set MapPointApp = GetObject(, "MapPoint.Application")
		' No instance found, create one.
		If Err <> 0 Then
			Err.Clear
			Set MapPointApp = CreateObject("MapPoint.Application")
			If Err = 0 then
				MapPointApp.Visible = True
				MapPointApp.UserControl = False
				MapPointApp.Activate
			else
				Msgbox "Unable to initialize Mappoint", 16, nameScript
				Err.Clear
				UseMappoint = False
				'''Because UseMappoint is set to false, there isn't a need to unset anything
				'place = ""
				'zoomToStartLoc = False
				'DropCrumbs = False
				'TrackVehicle = False
				Exit Sub
			End If
		End If
	End If

	if hideStan then MapPointApp.Toolbars.Item("Standard").Visible = False 'Hide surplus Toolbars
	if hideDraw then MapPointApp.Toolbars.Item("Drawing").Visible = False 'Hide surplus Toolbars

	Set ActiveMap = MapPointApp.ActiveMap
	With ActiveMap
		' Start of by Laidback 20040619
		if useCustIcon then
			if not FSO.FileExists(nameDir & cSymbol1) _
				or not FSO.FileExists(nameDir & cSymbol2) _
				or not FSO.FileExists(nameDir & cSymbol3) _
				or not FSO.FileExists(nameDir & cSymbol4) then
				useCustIcon = "Unable to find the following custom icons, disabling feature:"
				if not FSO.FileExists(nameDir & cSymbol1) _
					then useCustIcon = useCustIcon & vbCRLF & nameDir & cSymbol1
				if not FSO.FileExists(nameDir & cSymbol2) _
					then useCustIcon = useCustIcon & vbCRLF & nameDir & cSymbol2
				if not FSO.FileExists(nameDir & cSymbol3) _
					then useCustIcon = useCustIcon & vbCRLF & nameDir & cSymbol3
				if not FSO.FileExists(nameDir & cSymbol4) _
					then useCustIcon = useCustIcon & vbCRLF & nameDir & cSymbol4
				MsgBox useCustIcon, vbCritical, nameScript
				useCustIcon = False
			else
				cSymbol1 = .Symbols.Add(nameDir & cSymbol1)
				cSymbol2 = .Symbols.Add(nameDir & cSymbol2)
				cSymbol3 = .Symbols.Add(nameDir & cSymbol3)
				cSymbol4 = .Symbols.Add(nameDir & cSymbol4)
			end if
		end if

		If UseDefaultMap AND delLastLoc Then .Datasets("Last Location").delete
		If UseDefaultMap AND delLastTrack Then .Datasets("Location History").delete
		' End of by Laidback 20040619


		Dim StartLoc
		Set StartLoc = .FindResults(place)(1) ' Middle of, uh, somewhere

		If DropCrumbs Then
			Set HistoryPushpins = .Datasets.AddPushpinSet("Location History")
			If Err <> 0 Then
				Err.Clear
				Set HistoryPushpins = .Datasets("Location History")
			End If
		End If

		' SMT 20040609
		'Set WLANPushpins = .Datasets.AddPushpinSet("Wireless LAN data")
		'If Err <> 0 Then
		'	Err.Clear
		'	Set WLANPushpins = .Datasets("Wireless LAN data")
		'End If

		Set WEPPushpins = .Datasets.AddPushpinSet(WEPPushpinSet)
		If Err <> 0 Then
			Err.Clear
			Set WEPPushpins = .Datasets(WEPPushpinSet)
		End If

		Set NonWEPPushpins = .Datasets.AddPushpinSet(NonWEPPushpinSet)
		If Err <> 0 Then
			Err.Clear
			Set NonWEPPushpins = .Datasets(NonWEPPushpinSet)
		End If
		'end smt 20040609

		Set pWEPPushpins = .Datasets.AddPushpinSet(pWEPPushpinSet)
		If Err <> 0 Then
			Err.Clear
			Set pWEPPushpins = .Datasets(pWEPPushpinSet)
		End If

		Set pNonWEPPushpins = .Datasets.AddPushpinSet(pNonWEPPushpinSet)
		If Err <> 0 Then
			Err.Clear
			Set pNonWEPPushpins = .Datasets(pNonWEPPushpinSet)
		End If


		If UseDefaultMap then 'Put the old datasets into the dictionary
			Dim objRecords, objDataSet
			Set objDataSet = .Dataset
			For Each objDataSet In .DataSets
				If InStr(objDataSet.Name, NonWEPPushpinSet) OR InStr(objDataSet.Name, WEPPushpinSet) OR _
					InStr(objDataSet.Name, pNonWEPPushpinSet) OR InStr(objDataSet.Name, pWEPPushpinSet) OR _
					InStr(objDataSet.Name, "Wireless LAN data") OR InStr(objDataSet.Name, "My Pushpins")Then
					Set objRecords = objDataSet.QueryAllRecords
					Do Until objRecords.EOF
						'objRecords.Pushpin.Highlight = True
						FindOrAddPushpin Loc, objRecords.Pushpin.Name, True
						objRecords.MoveNext
					Loop
				End if
			Next
			If UseSpeech then Say BSSID_Dictionary.Count & " Records imported"
		End if


		If TrackVehicle Then
			Set MotionPushpins = .Datasets.AddPushpinSet("Last Location")
			If Err <> 0 Then
				Err.Clear
				Set MotionPushpins = .Datasets("Last Location")
			End If

			Set Vehicle = MotionPushpins("Last Location")
			If Err <> 0 Then
				Err.Clear
				Set Vehicle = FindOrAddPushpin(StartLoc, "Last Location", False)
			End If

			Vehicle.Symbol = 82		' red car, just like the stumblemobile :-)
			Vehicle.Highlight = True
			Vehicle.MoveTo (MotionPushpins)
			if zoomToStartLoc then MotionPushpins.ZoomTo	'Laidback 050504
		End If
	End With
	Initialized = True
	IsScanning = True
End Sub



'######################################################################
'######################################################################
'Useful subroutines
'######################################################################
'######################################################################


'smt 090604
'Function SSIDIcon(SSID)
'	Dim i, s
'	s = 0
'	For i = 1 To Len(SSID)
'		s = s + Asc(Mid(SSID, i, 1))
'	Next
'	SSIDIcon = 17 + (s Mod 47)
'End Function

'######################################################################
Sub HighlightOnMap(BSSID, SSID)
'######################################################################
	If Not LastHighlighted Is Nothing Then
		LastHighlighted.Highlight = False
		LastHighlighted.BalloonState = 0
	End If
	If BSSID_Dictionary.Exists(BSSID) Then
		Set LastHighlighted = BSSID_Dictionary.Item(BSSID)
		LastHighlighted.Highlight = True
		LastHighlighted.BalloonState = 2
		LastHighlighted.GoTo
	Else
		Msgbox SSID & " not found on map!", 16, nameScript
	End If
End Sub

'######################################################################
Function FindOrAddPushpin(Loc, Title, InDict)
'######################################################################
	On Error Resume Next
	Dim pp
	Set pp = Nothing
	Set pp = ActiveMap.AddPushpin(Loc, Title)
	If pp Is Nothing Then Set pp = ActiveMap.FindPushpin(Title)
	If InDict Then Set BSSID_Dictionary.Item(Title) = pp
	Set FindOrAddPushpin = pp
End Function

'Sub AddToDefaultMap(BSSID, SSID) Just Testing
'	MapPointApp.OpenMap "d:\program files\network stumbler\map.ptm"
'End Sub



'######################################################################
'######################################################################
'Events
'######################################################################
'######################################################################


'######################################################################
Sub OnGPSPositionMappoint(Lat, Lon, Alt)
'######################################################################
	If Not UseMappoint Then Exit Sub
	If Not Initialized Then Initialize

	If HadGPSData Then
		' If we haven't moved, do nothing.
		If GPSLatitude = Lat And GPSLongitude = Lon And GPSAltitude = Alt Then Exit Sub
	End If
	GPSLatitude = Lat
	GPSLongitude = Lon
	GPSAltitude = Alt

	Dim LastLocation
	Set LastLocation = ActiveMap.GetLocation(Lat, Lon, Alt)

	' Start of by Laidback 20040509
	'If DropCrumbs Then
	'	Dim Crumb
	'	Set Crumb = FindOrAddPushpin(LastLocation, Lat & "  " & Lon & "  " & Alt, False)
	'	Crumb.Symbol = 16 '16 Small black circle
	'	Crumb.MoveTo (HistoryPushpins)
	'End If

	'smt 20040611
	If Distance(crumbLat, crumbLon, Lat, Lon) > CrumbGap Then
		If DropCrumbs Then
			'end smt 20040611
			Dim Crumb
			Set Crumb = FindOrAddPushpin(LastLocation, Lat & "  " & Lon & "  " & Alt, False)
			Crumb.Symbol = 16 ' Small black circle, 16=Black, 17=Red
			'Crumb = ActiveMap.Shapes.AddRadius(20)
			Crumb.MoveTo (HistoryPushpins)
			'smt 20040611
		End If
		If WriteTrack Then TrackDraw Lat, Lon
		crumbLat = Lat
		crumbLon = Lon
	End If
	'end smt 20040611
	' End of by Laidback 20040509

	If TrackVehicle Then
		' Move the visual indicator to the new location.
		Set Vehicle.Location = LastLocation
		If CentreVehicle Then
			' If scanning or first position, center the map on the new location
			if (IsScanning Or Not HadGPSData) Then UpdateCurrentLocation Lat, Lon	' by Laidback 030504
		End If
	End If
	HadGPSData = True
End Sub



'######################################################################
' Called when user requests that scanning start, or when scanning is started automatically.
Sub OnEnableScanMappoint()
'######################################################################
	If Not UseMappoint Then Exit Sub
	If Not HadGPSData Then Exit Sub ' Discard while no GPS

	If Not Initialized Then Initialize
	IsScanning = True
End Sub



'######################################################################
' Called when user requests that scanning stop.
Sub OnDisableScanMappoint()
'######################################################################
	on error resume next
	If Not UseMappoint Then Exit Sub

	'If WLANPushpins Is Nothing Then
	If not WEPPushpins Is Nothing OR not NonWEPPushpins Is Nothing Then
		' Blah
		' Start of by Laidback 20040531
		' WLANPushpins.ZoomTo
		If DropCrumbs Then
			HistoryPushpins.ZoomTo
		Else
			NonWEPPushpins.ZoomTo	'smt 20040609
		End if
		' End of by Laidback 20040531
	End If
	IsScanning = False
End Sub



'######################################################################
Sub OnScanResultMappoint(SSID, BSSID, CapFlags, Signal, Noise, LastSeen)
'######################################################################
	' SSID : String : SSID (Network name)
	' BSSID : String : BSSID (MAC address)
	' CapFlags : Integer : 802.11 capability flags
	' Signal : Integer : signal level (dBm)
	' Noise : Integer : noise level(dBm)
	' LastSeen : Time

	If Not UseMappoint Then Exit Sub

	' Start of by Laidback 20040531
	Dim foundBSS, newLocation
	Dim lMove, lSNR
	Set newLocation = ActiveMap.GetLocation(GPSLatitude, GPSLongitude, GPSAltitude)
	lSNR = Signal - Noise	'(-Noise - -Signal), Get it for next time
	If BSSID_Dictionary.Exists(BSSID) Then
		' Start of by Laidback 20040621
		'Set foundBSS = BSSID_Dictionary.Item(BSSID)
		'Set foundBSS.Location = newLocation
		lMove = False
		if BSSID_Signal(BSSID) < lSNR then 'only move if SNR is stronger
			lMove = True
			Set foundBSS = BSSID_Dictionary.Item(BSSID)
			Set foundBSS.Location = newLocation
			BSSID_Signal.item(BSSID) = lSNR
		End if
		' End of by Laidback 20040621
	Else
		Set foundBSS = FindOrAddPushpin(newLocation, BSSID, True)
		'smt 20040609
		'foundBSS.MoveTo (WLANPushpins)
		'foundBSS.Symbol = SSIDIcon(SSID)
		'end smt 090604
		' Start of by Laidback 20040619
		Iconify foundBSS, CapFlags
		lMove = True
		Set BSSID_Signal.item(BSSID) = newLocation
		BSSID_Signal.item(BSSID) = lSNR
	End If
	' End of by Laidback 20040619
	If lMove then
		foundBSS.Note = "SSID:  " & SSID & vbCrLf & _
		"BSSID:  " & BSSID & vbCrLf & _
		"CapFlags:  " & ListFlags(CapFlags) & " (" & Hex(CapFlags) & ")" & _
		"SNR:  " & lSNR
		Set newLocation = Nothing
	End If
' End of by Laidback 20040531
End Sub



'######################################################################
' Called to indicate that NetStumbler has changed its location information
' for a BSSID. The new location may not necessarily be the place where you
' are right now.
' History: New in 0.4.
Sub OnPositionChangeMappoint(SSID, BSSID, CapFlags, MaxSNR, Lat, Lon, Alt, FixType)
'######################################################################
	' SSID : String : SSID (Network name)
	' BSSID : String : BSSID (MAC address)
	' CapFlags : Integer : 802.11 capability flags
	' MaxSNR: Integer : highest seen signal-to-noise ratio (dB) that had a position fix associated with it
	' Lat : Double : Newly calculated latitude, degrees
	' Lon : Double : Newly calculated longitude, degrees
	' Alt : Double : Newly calculated altitude (currently not calculated)
	' FixType : Integer : Reserved for future use.

	If Not UseMappoint Then Exit Sub

	If Not Initialized Then
		' To get here, start with no script, start scan, then enable script
		Initialize
		IsScanning = True
	End If

	Dim foundBSS, newLocation
	Set newLocation = ActiveMap.GetLocation(Lat, Lon, Alt)

	If BSSID_Dictionary.Exists(BSSID) Then
		Set foundBSS = BSSID_Dictionary.Item(BSSID)
		Set foundBSS.Location = newLocation
	Else
		Set foundBSS = FindOrAddPushpin(newLocation, BSSID, True)
		'smt 090604
		'foundBSS.MoveTo (WLANPushpins)
		' Start of by Laidback 20040619
		Iconify foundBSS, CapFlags
	End If
	' End of by Laidback 20040619

	foundBSS.Note = "SSID:  " & SSID & vbCrLf & _
	"BSSID:  " & BSSID & vbCrLf & _
	"CapFlags:  " & ListFlags(CapFlags) & " (" & Hex(CapFlags) & ")" & _
	"SNR:  " & MaxSNR
	Set newLocation = Nothing
End Sub



'######################################################################
' Called when a scan cycle has completed (typically right before a new one starts).
Sub OnScanCompleteMappoint(FoundNew, SeenBefore, LostContact, BestSNR)
'######################################################################
	' FoundNew : Integer : Count of new BSSIDs
	' SeenBefore : Integer : Count of not-new BSSIDs
	' LostContact : Integer : Count of BSSIDs missed since last scan
	' BestSNR : Integer : SNR of strongest signal (dBm)

	'smt 110604
	If WriteTrack or DropCrumbs Then Strength = Fix(BestSNR / 10)
	'end smt 110604
End Sub



'######################################################################
'######################################################################
'More useful subroutines
'######################################################################
'######################################################################



'######################################################################
Function ListFlags (CapFlags)
'######################################################################
	Dim Flags
	Flags = ""
	If (CapFlags and 1) Then Flags = Flags & "ESS "
	If (CapFlags and 2) Then Flags = Flags & "IBSS "
	If (CapFlags and 16) Then Flags = Flags & "WEP "
	ListFlags = Trim(Flags)
End Function



'######################################################################
Sub Iconify (ByRef foundBSS, CapFlags)
'######################################################################
	'If ((CapFlags / 16) Mod 2) = 1 Then
	'	foundBSS.Symbol = WEPIcon
	'	foundBSS.MoveTo(WEPPushpins)
	'Else
	'	foundBSS.Symbol = NonWEPIcon
	'	foundBSS.MoveTo(NonWEPPushpins)
	'End if
	With foundBSS
		If useCustIcon then
			Select Case CapFlags and 19 'Bitwise!
				Case 17
					.Symbol = cSymbol1
					.MoveTo(WEPPushpins)
				Case 1
					.Symbol = cSymbol2
					.MoveTo(NonWEPPushpins)
				Case 18
					.Symbol = cSymbol3
					.MoveTo(pWEPPushpins)
				Case 2
					.Symbol = cSymbol4
					.MoveTo(pNonWEPPushpins)
			End Select
		ElseIf (CapFlags and 16) Then
			.Symbol = WEPIcon
			.MoveTo(WEPPushpins)
		Else
			.Symbol = NonWEPIcon
			.MoveTo(NonWEPPushpins)
		End if
	End With
End Sub

' Start of by Laidback 030504
'######################################################################
Sub UpdateCurrentLocation (thisLat, thisLon)
'######################################################################
	On Error Resume Next
	ActiveMap.GetLocation(FormatMP(thisLat), FormatMP(thisLon)).Goto()
End Sub

'smt 110604
'######################################################################
Sub TrackDraw (thisLat, thisLon)
'######################################################################
	Dim LL, NL, Track
	On Error Resume Next

	' Bail out if we haven't moved.
	If thisLat = crumbLat AND thisLon = crumbLon Then Exit Sub

	' Laidback 20040619
	If crumbLat = "" AND crumbLon = "" Then Exit Sub

	' Set NL to our current location
	Set NL = ActiveMap.GetLocation(FormatMP(thisLat), FormatMP(thisLon))
	If Err.Number <> 0 Then Exit Sub

	' Set LL to our last location
	Set LL = ActiveMap.GetLocation(FormatMP(crumbLat), FormatMP(crumbLon))
	If Err.Number <> 0 Then Exit Sub

	' draw a line between the two
	Set Track = ActiveMap.Shapes.AddLine(NL, LL)

	' Set the properties of the line
	Track.Line.ForeColor = TrackColor(Strength)	'plot the trail in color according to SNR levels
	Track.Line.Weight = TrackWidth

	NL.GoTo
	If Err.Number <> 0 Then Exit Sub

	Set NL = Nothing
	Set LL = Nothing

End Sub
'end smt 20040611


'######################################################################
Function FormatMP (thisCoord)
'######################################################################
	FormatMP = FormatNumber(thisCoord, 5)
End Function
' End of by Laidback 20040503

' Start of by Laidback 20040509
'######################################################################
Function Distance (Lat1, Lon1, Lat2, Lon2)
'######################################################################
	Dim RLat1, RLon1, RLat2, RLon2, RDist, x
	const RadiusEarth = 6378000 'meters

	if Lat1=Lat2 and Lon1=Lon2 then
		Distance = 0
		exit function
	end if

	RLat1 = Radians(Lat1)
	RLon1 = Radians(Lon1)
	RLat2 = Radians(Lat2)
	RLon2 = Radians(Lon2)

'	Distance = Sqr((Lat1 - Lat2) ^ 2 + ((Lon1 - Lon2) * 1.6172) ^ 2 ) * 225282
	x = sin(RLat1) * sin(RLat2) + cos(RLat1) * cos(RLat2) * cos(RLon2 - RLon1)
	if (x = 0) then
		Rdist = 2 * atn(1)
	else
		Rdist = atn(sqr(1-x^2)/x)
	end if
	Distance = ABS(RadiusEarth * RDist)
End Function



'######################################################################
Function Radians (Degrees)
'######################################################################
	Radians = Degrees * atn(1) / 45		'=Degrees/57.2958
End Function
' End of by Laidback 20040509

