' Copyright Marius Milner 2004.
' Use with NetStumbler. Edit. Enjoy.

const nameScript = "ns04master"



'20040426 Marks changes made to use speech, when you are not lucky enough to have
'         Mappoint.  Also adds ability to turn off signal strength playing - TPEER

'20040429a Marks changes made to allow setting of voice - find \HKEY_LOCAL_MACHINE\SOFTWARE\
'          Microsoft\Speech\Voices\Tokens - that should give you a list of voices you can set
'          it starts at 0, not 1.  Change the line "Set TTS.voice = TTS.getvoices().item(X)" where X
'          equals the number of the voice you want - TPEER

'20040429b Marks changes made to store the WEP status with the SSID, so the 'Stumbler Lady' will
'          add "is Open" or "is Closed" - TPEER

'20040503 Start of by Laidback 030504
'         Start of by Laidback - Start of Changes made by Laidback
'         End of by Laidback - End of Changes made by Laidback
'         Code thanks to TrackNS & rogerRabbit!
'         End of by Laidback 030504

'20040504 Marks change to allow override of default voice by this script
'         Also set VoiceNum to the number of the voice you want to use
'         Will say the name of the voice IF you override the default - TPEER

'20040506 Changes to Voice stuff.  If VoiceNum = Empty, the default voice will used
'         Modified the hello world message to be the name of the voice used
'         organized the user changeable switches/variables a little
'         Changed all mappoint stuff to not be checked unless UseMAppoint = True - TPEER

'20040509 Version 00:18 - Removed everything to do with zoomcontrol.txt! - Laidback

'20040511 Version 00:19 - Added message boxes if unable to initialize voice or mappoint
'         Added variable for what to add to WEP and NOWEP SSIDs
'         Fixed bug with UseSpeech - TPEER

'20040531 Version 00:20 310504 - Laidback
'         Added code to remove surplus toolbars
'         Added code to change crumb gap
'         Distance function code courtesy of RedRocket & TrackNS v2!

'20040531 version 00:21 310504 - Laidback
'         if DropCrumbs set, pressing stopscan zooms to Crumbs else zooms to WiFi points found.
'         Should plot all AP's in MapPoint
'         Msgbox SSID, 16, nameScript

'20040609 Split pushpin group into two: open/closed
'         Created user-configurable icons for open/closed APs
'         - smt

'20040611 Added track lines colored by signal strength

'20040618 Added default map functionality

'20040619 Version 00:22 190604 - Laidback
'         Add custom Icons
'         If opening default map you can remove the last vehicle location
'         If opening default map you can remove the last vehicle track

'20040621 Version 00:23 210604 - Laidback
'         Corrected Aps not being placed at highest SNR
'
'20040623 Version 00:24 230604 - Laidback
'         Included routine to add APs already on default map into script
'
'20040706 Version 00:25 060704 - Laidback
'         Includes option to not centre map on vehicle
'
'20040806 Glynne
'         Added voice announcement of GPS status change

'20040916 goldfndr
'	Reordered history (this section) in chronological order
'	Changed datestamps in script header to ISO-8601 (the "I" means International)
'	Split into separate scripts for easier maintenance
'	Removed many pointless comments - they consisted of dates or who added what, use diff instead
'	Added DiGLE functionality
'	Check NetStumbler folder for WAVs and substitute if word match
'	Other speech substitutions

'20040918 goldfndr
'	Speech speed checks: tells speed at intervals, when speeding, when stopped, reacts to buggy GPS unit
'	Speech SSID substitution: if enabled, changes particular types to constants - better for WAV files
'	More code optimizations

'20041030 goldfndr
'	Split appended speech (AddWep/strYesWep/StrNonWep) to separate pronnciation - better for WAV files
'	Option to configure whether speed callouts occur during scanning - nice if you have WAVs
'	Option to say speed as two numbers (e.g. 55 -> 50,5) - better for WAVs
'	Option to configure pronunciation of blank/null/empty SSIDs - allows WAV effects
'	Option for a specific folder for WAVs - tidier program/script folder
'	Option for what to say (if anything) if SSID is null/empty
'	Option to shorten common default SSIDs (initially Apple Network and 2WIRE)
'	If WEP/AP type isn't appended, try to speak simultaneously rather than haltingly
'	Speech SSID substitution even for unmatched (unlikely but perhaps possible)
'	Bugfix: Check that custom icons (symbols) are actually available, disable if not
'	Bugfix: use pushpin set names rather than any hardcoding


'20041124 goldfndr
'	Threaded speech!
'	Bugfix?: DiGLE didn't have OnGPSPosition call, I guess nobody tested this! Still not working for me
'	Option to check constant coordinates has been split out from the No GPS reporting option



Dim nameDir

Dim FSO : Set FSO = CreateObject("Scripting.FileSystemObject")
If Err.Number <> 0 Then
	MsgBox "FSO initialisation failed!", 16, nameScript
End If

Dim WSH : Set WSH = CreateObject("WScript.Shell")
If Err.Number <> 0 Then
	MsgBox "WSH Shell initialisation failed!", 16, nameScript
Else
	nameDir = WSH.RegRead("HKCU\Software\Bogosoft\NetStumbler\Settings\Script Name")
	nameDir = FSO.GetParentFolderName(nameDir)
	'nameDir = "d:\program files\network Stumbler\TrackNS\"
	If Not FSO.FolderExists(nameDir) Then
		MsgBox "Netstumbler Folder Not Found!", 16, nameScript
	Else
		nameDir = nameDir & "\"
	End If
End If



Dim UseMappoint
Dim UseDiGLE
Dim UseSpeech
Dim UseAudio
Dim UseSignalStr


IncludeFile "ns04settings.vbs"

If UseSpeech then IncludeFile "ns04speech.vbs"		'Part of mappoint uses speech, so do speech first
If UseMappoint then IncludeFile "ns04mappoint.vbs"
If UseDiGLE then IncludeFile "ns04digle.vbs"



'######################################################################
'Useful subroutines
'######################################################################
Private Sub IncludeFile (ByVal RelativeFileName)
	IncludeFileAbs FSO.BuildPath(nameDir, RelativeFileName)
End Sub

' Includes a file in the global namespace of the current script.
' The file can contain any VBScript source code.
' The path of the file name must be specified absolute (or
' relative to the current directory).
Private Sub IncludeFileAbs (ByVal FileName)
	Const ForReading = 1
	Dim f: set f = FSO.OpenTextFile(FileName,ForReading)
	Dim s: s = f.ReadAll()
'	MsgBox "About to executeglobal: " & FileName
	ExecuteGlobal s
'	MsgBox "Finished with executeglobal: " & FileName
End Sub



'######################################################################
'######################################################################
'Events
'######################################################################
'######################################################################


'######################################################################
Sub OnGPSPosition(Lat, Lon, Alt)
'######################################################################
	' Lat : double : Latitude, degrees east
	' Lon : double : Longitude, degrees north
	' Alt : double : Altitude above sea level, meters

	If UseMappoint then OnGpsPositionMappoint Lat, Lon, Alt
	If UseSpeech then OnGpsPositionSpeech Lat, Lon, Alt
	If UseDiGLE then OnGPSPositionDiGLE Lat, Lon, Alt
End Sub


'######################################################################
' Called when user requests that scanning start, or when scanning is started automatically.
Sub OnEnableScan()
'######################################################################
	If UseMappoint then OnEnableScanMappoint
	If UseSpeech then OnEnableScanSpeech
End Sub


'######################################################################
' Called when user requests that scanning stop.
Sub OnDisableScan()
'######################################################################
	If UseMappoint then OnDisableScanMappoint
	If UseSpeech then OnDisableScanSpeech
End Sub


'######################################################################
Sub OnScanResult(SSID, BSSID, CapFlags, Signal, Noise, LastSeen)
'######################################################################
	' SSID : String : SSID (Network name)
	' BSSID : String : BSSID (MAC address)
	' CapFlags : Integer : 802.11 capability flags
	' Signal : Integer : signal level (dBm)
	' Noise : Integer : noise level(dBm)
	' LastSeen : Time

	If UseMappoint Then OnScanResultMappoint SSID, BSSID, CapFlags, Signal, Noise, LastSeen
	If UseSpeech Then OnScanResultSpeech SSID, BSSID, CapFlags, Signal, Noise, LastSeen
End Sub



'######################################################################
' Called to indicate that NetStumbler has changed its location information
' for a BSSID. The new location may not necessarily be the place where you
' are right now.
' History: New in 0.4.
Sub OnPositionChange(SSID, BSSID, CapFlags, MaxSNR, Lat, Lon, Alt, FixType)
'######################################################################
	' SSID : String : SSID (Network name)
	' BSSID : String : BSSID (MAC address)
	' CapFlags : Integer : 802.11 capability flags
	' MaxSNR: Integer : highest seen signal-to-noise ratio (dB) that had a position fix associated with it
	' Lat : Double : Newly calculated latitude, degrees
	' Lon : Double : Newly calculated longitude, degrees
	' Alt : Double : Newly calculated altitude (currently not calculated)
	' FixType : Integer : Reserved for future use.

'	TTS.Speak SSID, SVSFlagsAsync
	If UseMappoint then OnPositionChangeMappoint SSID, BSSID, CapFlags, MaxSNR, Lat, Lon, Alt, FixType
End Sub



'######################################################################
' Called when a scan cycle has completed (typically right before a new one starts).
Sub OnScanComplete(FoundNew, SeenBefore, LostContact, BestSNR)
'######################################################################
	' FoundNew : Integer : Count of new BSSIDs
	' SeenBefore : Integer : Count of not-new BSSIDs
	' LostContact : Integer : Count of BSSIDs missed since last scan
	' BestSNR : Integer : SNR of strongest signal (dBm)

	'If UseSpeech And (New_SSIDs.Count > 0) Then 20040511
	If UseMappoint then OnScanCompleteMappoint FoundNew, SeenBefore, LostContact, BestSNR
	If UseDiGLE then OnScanCompleteDiGLE FoundNew, SeenBefore, LostContact, BestSNR
	If UseSpeech then
		OnScanCompleteSpeech FoundNew, SeenBefore, LostContact, BestSNR
	ElseIf UseAudio Then
		OnScanCompleteAudio FoundNew, SeenBefore, LostContact, BestSNR
	End If
End Sub



'######################################################################
Sub OnGPSTimeout()
'######################################################################
	If UseSpeech then OnGPSTimeoutSpeech
	If UseDiGLE then OnGPSNoneDiGLE
End Sub



'######################################################################
Sub OnGPSNoFix()
'######################################################################
	If UseSpeech then OnGPSNoFixSpeech
	If UseDiGLE then OnGPSNoneDiGLE
End Sub



'######################################################################
Sub OnGPSSpeed(Speed)
'######################################################################
	' Speed : double : Speed, knots
	If UseSpeech then OnGPSSpeedSpeech Speed
	If UseDiGLE then OnGPSSpeedDiGLE Speed
End Sub



'######################################################################
'######################################################################
'######################################################################



'######################################################################
' Called when a scan cycle has completed (typically right before a new one starts).
Sub OnScanCompleteAudio(FoundNew, SeenBefore, LostContact, BestSNR)
'######################################################################
	'This is only called if UseSpeech is false and UseAudio is true
	'It could be in its own file but that would be wasteful
	If FoundNew > 0 Then
		PlaySound "ns-aos-new.WAV"
	ElseIf LostContact > 0 Then
		PlaySound "ns-los.WAV"
	ElseIf SeenBefore > 0 Then
		If UseSignalStr Then
			'NOTE: THIS SHOULD BE DISABLED IF MIDI IS ENABLED
			' Still seeing some
			Dim SNRWav
			SNRWav=Int(BestSNR / 10)
			If SNRWav > 6 then SNRWav = 6		'It's now an integer from 0 to 6
			PlaySound "ns-signal-" & SNRWav & ".WAV"
		End If
	Else
		' Nothing seen
		PlaySound "ns-tick.WAV"
	End If
End Sub
