'This file is designed to be GlobalExecute'd into the master script
'It contains all settings


'************ Master User Configurable Switches ************
'***********************************************************
'Mapping software; pick one?
UseMappoint = False	'***** Mappoint:  This overrides DropCrumbs and TrackVehicle
UseDiGLE = True	'***** DiGLE:  Free mapping utility; see WiGLE.net; also Musatcha's software


'***** Speech:  Speak names of networks in view
UseSpeech = True


'***** Sounds:  ' Non-speech audio - if using speech this may trigger if no new ssids to say
UseAudio = True


'***** SignalStrength:  MIDI obsoletes this; True if you want varying signal strength sounds
		'if using speech it might trigger if there are no new ssids to say, and UseAudio = True
UseSignalStr = False


'***********************************************************
'****************End of master switches*********************
'***********************************************************


RunDefs


'***********************************************************
'***********************************************************
if UseMappoint then
'***********************************************************
'***** Beginning of Mappoint-specific settings
'***********************************************************

		'Do you want to use a default map?
const UseDefaultMap = False

		'self explanatory - only used if UseDefaultMap is True
const DefaultMapLocation = "C:\utils\carputer\Map.ptm"

		'True to delete the last vehicle location and/or last track - only if using default map
const delLastLoc = True
const delLasttrack = True

		'Enter your starting location (street,#, city, country)
const place = "Deer Park, TX"

		'True if you want MapPoint to zoom to start location entered in 'place' above
const zoomToStartLoc = True

		'True to put black dots everywhere we go, False otherwise
const DropCrumbs = True

		'Create a track line?
const WriteTrack = False

		'number of pixels wide the track line (if enabled) will be
const TrackWidth = 3

		'Use 0, 50, 100 etc.; also used for tracks
const CrumbGap = 10

		'True to follow your location while scanning
const TrackVehicle = True

		'True to centre map on vehicle - Laidback 20040706
const CentreVehicle = True

		'True to hide standard/drawing toolbars
const hideStan = True
const hidedraw = True

		'True to use custom icons
useCustIcon = True

		'Custom Icons are branched off the script's folder
cSymbol1 = "Cicons\$lwfw.ico" 'Icon file name of wep'd AP
cSymbol2 = "Cicons\$lwfnw.ico" 'Icon file name of Open AP
cSymbol3 = "Cicons\$lwfaw.ico" 'Icon file name of wep'd Peer
cSymbol4 = "Cicons\$lwfanw.ico" 'Icon file name of Open Peer

'***********************************************************
'***** End of Mappoint-specific settings
'***********************************************************
end if



'***********************************************************
'This section will be common to various mapping programs
if UseMappoint or UseMappoint then
'***********************************************************
		'MapPoint: Icons for WEP/Non-WEP APs; See www.msdn.microsoft.com/library/en-us/mappoint2004/BIZOMPSymbol.asp
		'Others: Which symbol (how many times to arrow down)
const WEPIcon = 1	'70
const NonWEPIcon = 2	'30

		'Pushpin set names or Waypoint "types" for WEP/Non-WEP APs and WEP/Non-WEP Peers
const WEPPushpinSet = "Closed APs"
const NonWEPPushpinSet = "Open APs"
const pWEPPushpinSet = "Closed Peer to Peer"
const pNonWEPPushpinSet = "Open Peer to Peer"
'***********************************************************
'***** End of general mapping settings
'***********************************************************
end if




'***********************************************************
'***********************************************************
if UseSpeech then
'***********************************************************
'***** Beginning of Speech-specific settings
'***********************************************************

'	A brief recommendation:				(have pregenerated WAVs available)
'This script checks for WAV files in the script's folder, and any filename matching what's said will be used.
'For example, if you come across an unconfigured Linksys AP, it'll play LINKSYS.WAV if available, otherwise talk.
'You can optimize this behavior for speeds and other common strings. Some of the most frequent SSIDs are:
'	3Com, ACTIONTEC, Adaptec, AirPort Network, Apple Network, belkin54g, default, flyingj, home, HGW600,
'	INTERMEC, linksys, linksys-g, Motorola, MSHOME, NETGEAR, sonicwall, SpeedStream, SST-PR-1, TA, tmobile,
'	Truckstop.neT, tsunami, Untitled, WaveLAN Network, Wireless, WLAN
'	Also see: http://www.wigle.net/wiki/index.cgi?CommercialSSID
'There may be other common ones; see what you have and consider using NS's "Merge" command (in the File menu).
'NS won't detect while speaking, and speech takes CPU, so WAVs are preferable. If you dislike effects/your voice:
'	http://www.research.att.com/~ttsweb/cgi-bin/ttsdemo	(try Lauren and Audrey)
'	http://en.wikipedia.org/wiki/Voice_synthesis#Examples_of_current_systems
'	http://www.tmaa.com/tts/engine_listing.htm
'	http://directory.google.com/Top/Computers/Speech_Technology/Speech_Synthesis?tc=1/
'or find someone willing to record them. Beware of copyrights and the Berne Convention!
'Note that tags - http://www.tapiex.com/help/WP_XML_TTS_Tutorial.htm - aren't skipped; anyone using them?

		'If true, spawn a separate thread specifically for speech/WAVs
const UseThreading = True

		'If not empty, where speech-WAVs are sought; if empty, looks in script's folder
const WavFolder = ".\WAV\"

		'Set this to the number of the voice you want to use - Setting to Empty will use the default voice
const VoiceNum = Empty

		'Say _something_ if null/empty SSID; AddWep appends if not overridden below; effect preferable
const strBlankSSID = ""

		'Shorten long default SSIDs; for now: "2WIRE###", "Apple Network ######"
const ShortenCommon = True

		'True if you want to hear WEP status after SSID; e.g. "is Open" (matches "is open.wav")
const AddWEP = True
const strNonWep = "is open"
const strYesWEP = "is closed"
const strUnkWep = "point"

		'True if you want a substitution for what was detected; set longer than "" for override
const substSpeech = True
const strSubstNonWepAP = ""
const strSubstYesWepAP = ""
const strSubstNonWepPeer = "ns-aos-new"
const strSubstYesWepPeer = "ns-aos-new"
const strSubstUnknown = "Point"

		'What is spoken when GPS is fixed, when it's timed out, and when it doesn't have a fix
const strGPS_State_0 = "GPS Locked"
const strGPS_State_1 = "GPS Timeout"
const strGPS_State_2 = "No GPS Fix"

		'What to multiply to Knots to get your speed (e.g. 1.15077945 for mph, 1.852 for kph)
		'Use Google calculator, e.g. "1.0 knots in kph"
const SpeedMultiplier = 1.15077945

		'Add this after applying multiplier (except 0), may be useful for warnings/smoothing
const SpeedOffset = -0.2

		'Nonzero if you want your speed called out occasionally, interval in seconds
		'TellNoGPS uses strGPS_State_1 or strGPS_State_2 (above)
const TellSpeed = True
const TellIfScanning = False
const TellNoGPS = 5
const TellStopped = 5
const TellSlow = 20
const TellMoving = 20
const TellSpeeding = 20

		'If you go faster than this speed, it'll warn you; set really high to disable
const SpeedingWarnAt = 75
const SpeedingWarning = "Speeding"

		'Nonzero if you like your non-slow speeds in round numbers, e.g. increments of 1/2/5 - easier WAVs
const SpeedSmoothing = 1

		'Nonzero (pause in milliseconds) if you want speeds over 20 spoken as two numbers - easier WAVs
		'Example: if speed was 55 and this was true, it would say "50" then say "5" and SpeedAppend
		'This is currently kludged, and if set will peg the CPU while waiting! Try Google '9.wav 80.wav'
const SpeedAsDigits = 500

		'Converted speeds above zero and below this are considered Slow
const SpeedSlowUntil = 5

		'True if you don't want slow speeds to have fractions - easier prefab WAVs
const SpeedSlowInteger = True

		'Added to speed callouts - easier prefab WAVs (e.g. "MPH" or " KPH" or " kliks")
const SpeedAppend = ""

		'This is an alternative to "0" & SpeedAppend - that's only after Multiplier and Offset are applied
		'Examples:
		'  If the GPS claims you've stopped (0 knots), it'll say this
		'  If you're going 0.05 knots and SpeedSlowInteger is true, it'd say "0" instead of this
		'This'll be helpful if NetStumbler ignores your GPS receiver's "fix" status (Deluo, DigiTraveler)
const SpeedGPSZero = "CarBrake"

		'If your GPS receiver gives non-zero coordinates even when it doesn't have a fix, set low
		'For example, Digitraveler and some Deluo units; NS seems to base Fix on coordinates
		'If you get zero coordinates on no fix and stable readings when stationary, set high
const ConstCoordCheck = 5


'***********************************************************
'***** End of Speech-specific settings
'***********************************************************
end if







Sub RunDefs
	if UseMappoint then
		'cSymbol1-4 are reused variables, so we can't make them const
		Dim cSymbol1, cSymbol2, cSymbol3, cSymbol4
		'useCustIcon, on which the variables above are dependent, gets disabled if icons are missing
		Dim useCustIcon
	end if
End Sub
