'This file is designed to be GlobalExecute'd into the master script
'It contains speech-specific variables and code


'######################################################################
'Initialization
'######################################################################

On Error Resume Next

const reg="HKCU\Volatile Environment\NS_"

Dim TTS : Set TTS = CreateObject("Sapi.SpVoice")
If Err <> 0 then
	UseSpeech = False
	MsgBox "Unable to wake up Stumbler: Err=" & Err, 16, nameScript
ElseIf TTS Is Nothing Then
	UseSpeech = False
	MsgBox "Unable to wake up Stumbler: TTS unset", 16, nameScript
Else
	Set TTS.voice = TTS.getvoices().item(VoiceNum) ' 20040429a
	TTS.Speak "Speech featuring " & TTS.getvoices().item(VoiceNum).getdescription
	If not AddWep then TTS.Priority = 2	'Mixed; we want voices simultaneous with MIDI and other sounds

	Dim Spoken_BSSIDs : Set Spoken_BSSIDs = CreateObject("Scripting.Dictionary")
	Dim New_SSIDs : Set New_SSIDs = CreateObject("Scripting.Dictionary")

	' GPS_State:
	'	0 = Working
	'	1 = Not working
	'	2 = Lost Sats
	'	> 2 = Dummy states
	Dim GPS_State : GPS_State = 3
	Dim SpeedSpokenAt : SpeedSpokenAt = -86400	'Yesterday
	Dim WasLat : WasLat = 0
	Dim WasLon : WasLon = 0
	Dim WasSame : WasSame = 0


	If UseThreading then
		OnEnableScanSpeech
	else
		'Get list of WAVs - this should perhaps be done with Scripting.Dictionary
		Dim f, fl
		if len(WavFolder) then set f = FSO.GetFolder(WavFolder) else set f = FSO.GetFolder(nameDir)
		Dim WAVs : WAVs=""
		for each fl in f.files
			if ".wav" = lcase(right(fl.name,4)) then
	'			MsgBox fl.name & vbTab & lcase(right(fl.name,4)), vbInformation, left(fl.name, len(fl.name)-4)
				WAVs = WAVs & vbCRLF & left(fl.name, len(fl.name)-4)
			end if
		next
		WAVs = WAVs & vbCRLF		'Start with vbCRLF, end with vbCRLF (for easier searching)
	'	MsgBox "WAVs: " & WAVs
		WAVs = lcase(WAVs)
	end if
End If



'######################################################################
Sub OnGPSPositionSpeech(Lat, Lon, Alt)
'######################################################################
' Start of by Glynne 060804
' If lat & lon = 0 we assume no GPS lock
' Not all GPS units report this way

	Dim Last_GPS_State : Last_GPS_State = GPS_State
	If 0 = Lat and 0 = Lon then
		GPS_State = 2
		If Last_GPS_State <> GPS_State then
			SayMixed strGPS_State_2
			SpeedSpokenAt = Timer
		end if
	elseif Lat = WasLat  and Lon = WasLon then
		'Same Lat/Lon; buggy GPS receiver?
		WasSame = WasSame + 1		'Should maybe multiply in case some seconds
		if WasSame >= ConstCoordCheck then
			SayMixed strGPS_State_2
			GPS_State = 2
			SpeedSpokenAt = Timer
			WasSame = 0
		end if
	else
		GPS_State = 0
		WasSame = 0
		WasLat = Lat
		WasLon = Lon
		If Last_GPS_State <> GPS_State then
			SayMixed strGPS_State_0
			SpeedSpokenAt = Timer
		end if
	end if
' End of by Glynne 060804
End Sub



'There might be ways to do these with class creation/destruction, but hopefully this will be adequate for now.
'######################################################################
Sub OnEnableScanSpeech()
	'If threaded, run thread as simultaneous; somehow I wasn't able to get cscript.exe running directly
	If UseThreading then WSH.Run "%COMSPEC% /k cscript.exe " & chr(34) & nameDir & "ns04thread.vbs" & chr(34), 1, False
End Sub
Sub OnDisableScanSpeech()
	If UseThreading then SayMixed "_EXIT_"
End Sub
'######################################################################



'######################################################################
Sub OnScanResultSpeech(SSID, BSSID, CapFlags, Signal, Noise, LastSeen)
'######################################################################
	' SSID : String : SSID (Network name)
	' BSSID : String : BSSID (MAC address)
	' CapFlags : Integer : 802.11 capability flags
	' Signal : Integer : signal level (dBm)
	' Noise : Integer : noise level(dBm)
	' LastSeen : Time

	'While actively scanning and having good GPS, don't bother with speed checks
	if 0 = GPS_State and not TellIfScanning then SpeedSpokenAt = Timer

	If Spoken_BSSIDs.Exists(BSSID) Then Exit Sub

'	TTS.Speak SSID, SVSFlagsAsync
'	New_SSIDs.Item(SSID) = 1
	Dim ComboSSID
	Select Case UCase(Trim(SSID))
		Case "NETGEAR","MSHOME"
			ComboSSID = lcase(SSID)
		Case "ACTIONTEC"
			ComboSSID = "Action Tec"
		Case ""
			ComboSSID = strBlankSSID
		Case Else
			ComboSSID = SSID
	End Select
	If ShortenCommon then	'Change default to avoid lengthy pronunciation?
		If 1 = Instr(SSID, "2WIRE") then ComboSSID = "2WIRE"
		If 1 = Instr(SSID, "Apple Network") then ComboSSID = "Apple Network"
	End If

	If AddWEP or substSpeech then
		Select Case CapFlags and 19		'Bitwise AND
			Case 1
				if substSpeech and len(strSubstNonWepAP) then
					ComboSSID = strSubstNonWepAP
				elseif AddWep and len(strNonWep) then
					ComboSSID = ComboSSID & vbCRLF & strNonWep
				end if
			Case 2
				if substSpeech and len(strSubstNonWepPeer) then
					ComboSSID = strSubstNonWepPeer
				elseif AddWep and len(strNonWep) then
					ComboSSID = ComboSSID & vbCRLF & strNonWep
				end if
			Case 17
				if substSpeech and len(strSubstYesWepAP) then
					ComboSSID = strSubstYesWepAP
				elseif AddWep and len(strYesWep) then
					ComboSSID = ComboSSID & vbCRLF & strYesWep
				end if
			Case 18
				if substSpeech and len(strSubstYesWepAP) then
					ComboSSID = strSubstYesWepAP
				elseif AddWep and len(strYesWep) then
					ComboSSID = ComboSSID & vbCRLF & strYesWep
				end if
			Case Else
				if substSpeech and len(strSubstUnknown) then
					ComboSSID = strSubstUnknown
				elseif AddWep and len(strUnkWep) then
					ComboSSID = ComboSSID & vbCRLF & strUnkWep
				end if
		End Select
	End If
	New_SSIDs.Item(ComboSSID) = 1
	Spoken_BSSIDs.Item(BSSID) = LastSeen	' Could check and see if it's been a long time, play again
End Sub



'######################################################################
' Called when a scan cycle has completed (typically right before a new one starts).
Sub OnScanCompleteSpeech(FoundNew, SeenBefore, LostContact, BestSNR)
'######################################################################
	' FoundNew : Integer : Count of new BSSIDs
	' SeenBefore : Integer : Count of not-new BSSIDs
	' LostContact : Integer : Count of BSSIDs missed since last scan
	' BestSNR : Integer : SNR of strongest signal (dBm)

	If (New_SSIDs.Count > 0) Then
		Dim n : n = New_SSIDs.Count
		Dim a : a = New_SSIDs.Keys
		Dim s : s = ""
		For i = 0 To n - 1
			s = s & a(i) & vbCRLF
		Next
		Say s
		New_SSIDs.RemoveAll
	End If
	'While actively scanning and having good GPS, don't bother with speed checks
	'if 0 = GPS_State and not TellIfScanning then SpeedSpokenAt = Timer
End Sub



' Start of by Glynne 060804
'######################################################################
Sub OnGPSTimeoutSpeech()
'######################################################################

	Dim Last_GPS_State : Last_GPS_State = GPS_State
	GPS_State = 1
	if Last_GPS_State <> GPS_State then
		SayMixed strGPS_State_1
		SpeedSpokenAt = Timer
	elseif SayAfter(TellNoGPS) then
		SayMixed strGPS_State_1
		SpeedSpokenAt = Timer
	end if
End Sub



'######################################################################
Sub OnGPSNoFixSpeech()
'######################################################################

	Dim Last_GPS_State : Last_GPS_State = GPS_State
	GPS_State = 2
	if Last_GPS_State <> GPS_State then
		SayMixed strGPS_State_2
		SpeedSpokenAt = Timer
	elseif SayAfter(TellNoGPS) then
		SayMixed strGPS_State_2
		SpeedSpokenAt = Timer
	end if
End Sub
' End of by Glynne 060804



'######################################################################
Sub OnGPSSpeedSpeech(Speed)
'######################################################################
	'Speed in knots

	if WasSame > 1 then exit sub	'Invalid data? Don't bother!

	if 0 = Speed then
		if SayAfter(TellStopped) then
			SayMixed SpeedGPSZero
			SpeedSpokenAt = Timer
		end if
		exit sub
	end if

	'GPS claims speed is non-zero, so let's do the math
	Speed = Speed * SpeedMultiplier + SpeedOffset	'Convert to preferred measurement
	if Speed < 0 then Speed = 0		'Normalize to zero

	'Don't smooth until after speeding warning check
	if Speed > SpeedingWarnAt and SayAfter(TellSpeeding) then
		SayMixed SpeedingWarning
		if SpeedSmoothing then Speed = Smooth(Speed)
		SaySpeed Speed
		SpeedSpokenAt = Timer
	elseif Speed < SpeedSlowUntil then
		if SayAfter(TellSlow) then
			if SpeedSlowInteger then Speed = Int(Speed)
			SaySpeed Speed
			SpeedSpokenAt = Timer
		end if
	elseif SayAfter(TellMoving) then
		if SpeedSmoothing then Speed = Smooth(Speed)
		SaySpeed Speed
		SpeedSpokenAt = Timer
	end if
End Sub



'######################################################################
Sub Say(strText)
'######################################################################
	if len(strText) < 1 then exit sub
	if UseThreading then
		on error resume next
		dim t : t = int(Timer)
		dim msg : msg = ""
		msg = WSH.RegRead(reg & t)

		if len(msg) > 0 then msg = msg & vbCRLF & strText	'append
		if len(msg) < 1 then msg = strText	'new string this second
		WSH.RegWrite reg & t, msg, "REG_SZ"
		exit sub
	end if
	if Instr(strText, vbCRLF) then	'If passed string with vbCRLF then split into separate parts
		Dim TextArray, index
		TextArray = Split(strText, vbCRLF)
		for index = 0 to UBound(TextArray)
			Say TextArray(index)
		next
		Exit Sub
	end if

'The PlaySound call  in 0.4.0 aborts the current WAV rather than playing both
'This is because it uses SND_ASYNC (return immediately) rather than SND_SYNC (when finished)
'While TTS.Speak is called here with SVSFlagsAsync, it seems to be synchronous

'ASYNCH has its GOOD side (while playing a sound, can also continue detecting)
'ASYNCH has its BAD side (if simultaneously found 3 WAV'd APs, only hear 3rd)
'Ideal is moving sound into another thread (so it won't interfere with scanning), then SYNCH=good

	'See if it's in our list of WAVs
	if Instr(WAVs, vbCRLF & lcase(strText) & vbCRLF) > 0 then
		PlaySound WavFolder & strText & ".WAV"
	else
		TTS.Speak strText, SVSFlagsAsync
	end if
End Sub



'######################################################################
Sub SayMixed(strText)
'######################################################################
	if UseThreading then
		WSH.RegWrite reg & "IMMED" , strText, "REG_SZ"
		exit sub
	end if
	'0=SPVPRI_NORMAL (no mixing of speech/WAV/MIDI)
	'+1=SPVPRI_ALERT (Alerts interrupt)
	'+2=SPVPRI_OVER (mixed, no sync)
'The goal here: mix speech that can occur at any time, but AddWep puts stuff in order.
	TTS.Priority = 2	'Mixed, no sync; useful for speeds and GPS alerts
	Say strText
	If AddWep then TTS.Priority = 0	'No mixing; we want "is open" playing after speech, never during!!!
End Sub



'######################################################################
Sub SaySpeed(speed)
'######################################################################
	if SpeedAsDigits and speed > 20 and speed mod 10 > 0 then
		if UseThreading then
			SayMixed Int(speed / 10) * 10 & vbCRLF & (speed mod 10) & SpeedAppend
		else
			SayMixed Int(speed / 10) * 10	'Passing 111 would say 110 then 1
			Pause (SpeedAsDigits / 1000)
			SayMixed (speed mod 10) & SpeedAppend
		end if
	else
		SayMixed speed & SpeedAppend
	end if
End Sub



'######################################################################
Function SayAfter(interval)
'######################################################################
	'interval in seconds; wait until after this before saying anything

	if 0 = interval then	'0 to disable
		SayAfter = False
		exit function
	end if

	'There's probably a clever one-liner with Mod
	Dim TimeNow : TimeNow = Timer
	if TimeNow < SpeedSpokenAt then TimeNow = TimeNow + 86400	'86400=SecsInDay; crossed Midnight

	SayAfter = (TimeNow > SpeedSpokenAt + interval)
	'if SayAfter then SpeedSpokenAt = Timer
End Function



'######################################################################
Function Smooth(Speed)
'######################################################################
	Speed = Int(Speed)	'We'd add 0.5 here for rounding BUT we'd added SpeedOffset earlier
	Smooth = Speed - Speed mod SpeedSmoothing
End Function



'######################################################################
Sub Pause(seconds)
'######################################################################
	'This is disgustingly kludged (a crude loop): we can't call WScript.Sleep or window.SetTimeOut
	'Since it will peg the CPU, alternatives are invited!
	Dim DigitTime : DigitTime = Timer
	'The following line make sure that if you're close to midnight, it won't wait forever
	If DigitTime + seconds > 86400 then Exit Sub

	Do While Timer - DigitTime < seconds
	'A "yield" call or progress would go here but it's lacking; if it existed, it MIGHT take too long
	Loop
End Sub
