'This file is designed to stand alone and NOT be GlobalExecute'd into the master script
'It contains speech-specific variables and code

'######################################################################
'Settings that should be moved into or read from ns04settings.vbs:
const dbg = True
const speechdelay = 2	'Speech occurs at least this many seconds behind real-time
const sleepdelay = 100	'Sleep interval while waiting for more speech


'######################################################################
'Global variables and constants to be used
Dim WSH : Set WSH = CreateObject("WScript.Shell")
Dim TTS : Set TTS = CreateObject("Sapi.SpVoice")
Dim FSO : Set FSO = CreateObject("Scripting.FileSystemObject")
const reg="HKCU\Volatile Environment\NS_"
const openevent = "HKCU\AppEvents\Schemes\Apps\.Default\Open\.Current\"
const closeevent = "HKCU\AppEvents\Schemes\Apps\.Default\Close\.Current\"

'######################################################################
'Initialization
'######################################################################
dim nameDir : nameDir = WSH.RegRead("HKCU\Software\Bogosoft\NetStumbler\Settings\Script Name")
nameDir = FSO.GetParentFolderName(nameDir)
'nameDir = "d:\program files\network Stumbler\TrackNS\"
If Not FSO.FolderExists(nameDir) Then
	MsgBox "Netstumbler Folder Not Found!", 16, nameScript
Else
	nameDir = nameDir & "\"
End If

'IncludeFile is spelled out here with ns04settings.vbs
Dim f: set f = FSO.OpenTextFile(FSO.BuildPath(nameDir, "ns04settings.vbs"),1)
Dim s: s = f.ReadAll()
ExecuteGlobal s
f.close

'Set exit flag to false
dim ExitNow : ExitNow = False

'Set timer
Dim secnow : secnow = int(Timer) - 60	'Give it a minute to catch up in case anything blocked
if secnow < 0 then secnow = secnow + 86400	'Rewind if this was started just after midnight


'Get list of WAVs - this should perhaps be done with Scripting.Dictionary
Dim fl
if len(WavFolder) then set f = FSO.GetFolder(WavFolder) else set f = FSO.GetFolder(nameDir)
Dim WAVS : WAVs=""
for each fl in f.files
	if ".wav" = lcase(right(fl.name,4)) then
'		MsgBox fl.name & vbTab & lcase(right(fl.name,4)), vbInformation, left(fl.name, len(fl.name)-4)
		WAVs = WAVs & vbCRLF & left(fl.name, len(fl.name)-4)
	end if
next
WAVs = WAVs & vbCRLF		'Start with vbCRLF, end with vbCRLF (for easier searching)
if dbg then WScript.Echo "WAVs: " & WAVs
WAVs = lcase(WAVs)

'Prep voice
Set TTS.voice = TTS.getvoices().item(VoiceNum) ' 20040429a
TTS.Priority = 2	'+2=SPVPRI_OVER (mixed, no sync)

'Disable sound events; might be WinXP-specific; only done because we spawn instead of using PlaySound
if len(WSH.RegRead(openevent)) > 0 then
	WSH.RegWrite reg & "OPEN", WSH.RegRead(openevent), "REG_SZ"
	WSH.RegWrite openevent, "", "REG_SZ"
end if
if len(WSH.RegRead(closeevent)) > 0 then
	WSH.RegWrite reg & "CLOSE", WSH.RegRead(closeevent), "REG_SZ"
	WSH.RegWrite closeevent, "", "REG_SZ"
end if

'######################################################################
'This is the main loop
'######################################################################
Do
	CheckImmed
	Check secnow - speechdelay
	if secnow <> int(Timer) Then
		'We're behind, so catch up one second at a time
		do
			secnow = secnow + 1
			if secnow = 86400 then secnow = 0
			CheckImmed
			Check secnow - speechdelay
		loop until secnow = int(Timer)
	else
		'We're ahead, so check for abort/etc. until lag
		do
			CheckImmed
			WScript.Sleep sleepdelay
		loop until secnow <> int(Timer)
		secnow = secnow + 1
	end if
Loop until ExitNow

On error resume next
'Reenable sound events; might be WinXP-specific
if len(WSH.RegRead(reg & "OPEN")) > 0 then WSH.RegWrite openevent, WSH.RegRead(reg & "OPEN"), "REG_SZ"
if len(WSH.RegRead(reg & "CLOSE")) > 0 then WSH.RegWrite closeevent, WSH.RegRead(reg & "CLOSE"), "REG_SZ"



'######################################################################
'Check for normal strings, e.g. APs
Sub Check(secs)
'######################################################################
	if secs < 0 then secs = secs + 86400
if dbg then WScript.Echo "secs = " & secs
	on error resume next
	dim msg : msg = WSH.RegRead(reg & secs)
	if err <> 0 then
'		if err <> -2147024894 then	'regkey not found
'			WScript.Echo err & " err at " & secs
'		end if
		on error goto 0
	else
if dbg then WScript.Echo vbTab & Chr(34) & msg & Chr(34)
		on error goto 0
		Say msg, False
		WSH.RegDelete reg & secs
	end if
End Sub



'######################################################################
'Check for immediate/special strings, e.g. GPS changes or exit command
Sub CheckImmed
'######################################################################
	on error resume next
	const immed = "IMMED"
if dbg then WScript.Echo immed
	dim msg : msg = WSH.RegRead(reg & immed)
	if err <> 0 then
'		if err <> -2147024894 then	'regkey not found
'			WScript.Echo err & " err at " & secs
'		end if
		on error goto 0
	else
		on error goto 0
if dbg then WScript.Echo vbTab & Chr(34) & msg & Chr(34)
		if msg = "_EXIT_" then
			ExitNow = True
if dbg then WScript.Echo " Caught exit!"
		else
			Say msg, True
		end if
		'Only delete it if it's the one we used, otherwise we might miss something
		if WSH.RegRead(reg & immed) = msg then
			WSH.RegDelete reg & immed
		else
if dbg then WScript.Echo vbTab & "... will next process: " & WSH.RegRead(reg & immed)
		end if
	end if
End Sub


'######################################################################
'Speak the parts, but if there's lots of speech then also check for immediate stuff.
'Note that this could be confusing if there's something immediate within a phrase.
' e.g. "20" "GPS change" "6 MPH" or "NETGEAR", GPS Nofix", "is closed"
'This also means that a vbCRLF in an immediate speech string will cause a crash.
Sub Say(strText, bImmed)
'######################################################################
	if len(strText) < 1 then exit sub
	if Instr(strText, vbCRLF) then	'If passed string with vbCRLF then split into separate parts
		Dim TextArray, index
		TextArray = Split(strText, vbCRLF)
		for index = 0 to UBound(TextArray)
			Say TextArray(index), bImmed
			if not bImmed then CheckImmed	'Already CheckImmed before everything, this does _after_
		next
		Exit Sub
	end if

'UNEDITED NOTES FOLLOW, THEY NEED TO BE REVISED FOR THIS THREADING MODEL!
'The PlaySound call  in 0.4.0 aborts the current WAV rather than playing both
'This is because it uses SND_ASYNC (return immediately) rather than SND_SYNC (when finished)
'While TTS.Speak is called here with SVSFlagsAsync, it seems to be synchronous

'ASYNCH has its GOOD side (while playing a sound, can also continue detecting)
'ASYNCH has its BAD side (if simultaneously found 3 WAV'd APs, only hear 3rd)
'Ideal is moving sound into another thread (so it won't interfere with scanning), then SYNCH=good

	'See if it's in our list of WAVs
if dbg then WScript.Echo vbTab & "Now saying: " & strText	
	if Instr(WAVs, vbCRLF & lcase(strText) & vbCRLF) > 0 then
		'It'd be good to know if there's a way to call MCI to speak a WAV;
		'As it is, "Open Program" and "Close Program" events will spawn/interfere; disabled earlier
		WSH.Run "sndrec32.exe /play /close " & WavFolder & "\" & strText & ".WAV", 0, True
	else
		TTS.Speak strText, SVSFlagsSync
	end if
End Sub

